﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Xml;
using System.Windows.Forms;

namespace SC2XMLParser
{
    public partial class Form1 : Form
    {
        XMLParse parser = new XMLParse();
        List<XmlNode> parentList = new List<XmlNode>();
        List<XmlNode> childList = new List<XmlNode>();
        
        public Form1()
        {
            InitializeComponent();
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();

            if (openFileDialog1.FileName != "")
            {
                
                parentList = parser.Parse(openFileDialog1.FileName);

                listBox1.Items.Clear();

                foreach (XmlElement i in parentList)
                {
                    //textBox1.AppendText(i.Name + "\n");
                    //
                    listBox1.Items.Add(i.Name);
                }
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            //TODO:Parse Parent nodes for unique children and attributes of those children
            childList = parser.ChildParse(listBox1.SelectedItem.ToString());

            textBox2.Clear();

            foreach (XmlNode i in childList)
            {
                textBox2.AppendText(i.Name + "\n");
                //listBox1.Items.Clear();
                //listBox1.Items.Add(i.Name);
                
            }

            textBox1.Text =
                "<<xmldoc " + listBox1.SelectedItem + ">>" +
                "\r\n<<description>><</description>>" +
                "\r\n<<attribute id=\"\">>ID of <</attribute>>" +
                "\r\n<<attribute default=\"1\">>states if this Parent is the Default parent. All Other parents will be derived from this parent. Attribute only needed if this node is the default<</attribute>>" +
                "\r\n" +
                "\r\n" + HandleChildren(childList)/* List Child Nodes here */ +
                "<</xmldoc>>" + 
                "\r\n\r\n----";
        }

        public string HandleChildren(List<XmlNode> children)
        {
            string childCode = "";

            foreach (XmlNode i in childList)
            {
                childCode += "<<child " + i.Name + ">>" +
                        "\r\n<<description>><</description>>" +
                        "\r\n<<attribute value=\"\">><</attribute>>" +
                        "\r\n<</child>>\r\n\r\n";
            }

            return childCode;
        }
    }
}
